/*
	desc      : test1.ex
	author    : raphael smart
	date      : may 2012

	licence/disclaimer:

	This software is provided 'as-is', without any express or implied warranty.
	In no event will the author be held liable for any damages arising from
	the use of this software.
*/

include lib/libcjson.e as json

--// main

	atom tok
	atom my_string, my_int, my_object, my_array
	atom new_obj

	my_string = json:new_string("\t")
	printf(1, "my_string = %s\n", { json:get_string(my_string) })
	printf(1, "my_string.to_string() = %s\n", { json:to_json_string(my_string) })
	json:put(my_string)

	my_string = json:new_string("\\")
	printf(1, "my_string = %s\n", { json:get_string(my_string) })
	printf(1, "my_string.to_string() = %s\n", { json:to_json_string(my_string) })
	json:put(my_string)

	my_string = json:new_string("foo")
	printf(1, "my_string = %s\n", { json:get_string(my_string) })
	printf(1, "my_string.to_string() = %s\n", { json:to_json_string(my_string) })

	my_int = json:new_int(9)
	printf(1, "my_int = %d\n", { json:get_int(my_int) })
	printf(1, "my_int.to_string() = %s\n", { json:to_json_string(my_int) })

	my_array = json:new_array()
	json:array_add(my_array, json:new_int(1))
	json:array_add(my_array, json:new_int(2))
	json:array_add(my_array, json:new_int(3))
	json:array_put_idx(my_array, 4, json:new_int(5))
	printf(1, "my_array=\n")
	for i = 0 to (json:array_length(my_array) - 1) do
		atom obj = json:array_get_idx(my_array, i)
		printf(1, "\t[%d] = %s\n", { i, json:to_json_string(obj) })
	end for
	printf(1, "my_array.to_string() = %s\n", { json:to_json_string(my_array) })

	my_object = json:new_object()
	json:object_add(my_object, "abc", json:new_int(12))
	json:object_add(my_object, "foo", json:new_string("bar"))
	json:object_add(my_object, "bool0", json:new_boolean(0))
	json:object_add(my_object, "bool1", json:new_boolean(1))
	json:object_add(my_object, "baz", json:new_string("bang"))
	json:object_add(my_object, "baz", json:new_string("fark"))
	json:object_del(my_object, "baz")

	/*json:object_add(my_object, "arr", my_array)*/
	printf(1, "my_object =\n")

procedure json_foreach(sequence k, atom v)
	printf(1, "\t%s: %s\n", { k, json:to_json_string(v) })
end procedure

	json:foreach(my_object, routine_id("json_foreach"))
	
	printf(1, "my_object.to_string() = %s\n", { json:to_json_string(my_object) })

	new_obj = json:tokener_parse("\"\u0003\"")
	printf(1, "new_obj.to_string() = %s\n", { json:to_json_string(new_obj) })
	json:put(new_obj)

	new_obj = json:tokener_parse("/* hello */\"foo\"")
	printf(1, "new_obj.to_string() = %s\n", { json:to_json_string(new_obj) })
	json:put(new_obj)

	new_obj = json:tokener_parse("// hello\n\"foo\"")
	printf(1, "new_obj.to_string() = %s\n", { json:to_json_string(new_obj) })
	json:put(new_obj)

	new_obj = json:tokener_parse("\"\\u0041\\u0042\\u0043\"")
	printf(1, "new_obj.to_string() = %s\n", { json:to_json_string(new_obj) })
	json:put(new_obj)

	new_obj = json:tokener_parse("null")
	printf(1, "new_obj.to_string() = %s\n", { json:to_json_string(new_obj) })
	json:put(new_obj)

	new_obj = json:tokener_parse("True")
	printf(1, "new_obj.to_string() = %s\n", { json:to_json_string(new_obj) })
	json:put(new_obj)

	new_obj = json:tokener_parse("12")
	printf(1, "new_obj.to_string() = %s\n", { json:to_json_string(new_obj) })
	json:put(new_obj)

	new_obj = json:tokener_parse("12.3")
	printf(1, "new_obj.to_string() = %s\n", { json:to_json_string(new_obj) })
	json:put(new_obj)

	new_obj = json:tokener_parse("[\"\\n\"]")
	printf(1, "new_obj.to_string() = %s\n", { json:to_json_string(new_obj) })
	json:put(new_obj)

	new_obj = json:tokener_parse("[\"\\nabc\\n\"]")
	printf(1, "new_obj.to_string() = %s\n", { json:to_json_string(new_obj) })
	json:put(new_obj)

	new_obj = json:tokener_parse("[null]")
	printf(1, "new_obj.to_string() = %s\n", { json:to_json_string(new_obj) })
	json:put(new_obj)

	new_obj = json:tokener_parse("[]")
	printf(1, "new_obj.to_string() = %s\n", { json:to_json_string(new_obj) })
	json:put(new_obj)

	new_obj = json:tokener_parse("[false]")
	printf(1, "new_obj.to_string() = %s\n", { json:to_json_string(new_obj) })
	json:put(new_obj)

	new_obj = json:tokener_parse("[\"abc\",null,\"def\",12]")
	printf(1, "new_obj.to_string()=%s\n", { json:to_json_string(new_obj) })
	json:put(new_obj)

	new_obj = json:tokener_parse("{}")
	printf(1, "new_obj.to_string()=%s\n", { json:to_json_string(new_obj) })
	json:put(new_obj)

	new_obj = json:tokener_parse("{ \"foo\": \"bar\" }")
	printf(1, "new_obj.to_string()=%s\n", { json:to_json_string(new_obj) })
	json:put(new_obj)

	new_obj = json:tokener_parse("{ \"foo\": \"bar\", \"baz\": null, \"bool0\": true }")
	printf(1, "new_obj.to_string()=%s\n", { json:to_json_string(new_obj) })
	json:put(new_obj)

	new_obj = json:tokener_parse("{ \"foo\": [null, \"foo\"] }")
	printf(1, "new_obj.to_string()=%s\n", { json:to_json_string(new_obj) })
	json:put(new_obj)

	new_obj = json:tokener_parse("{ \"abc\": 12, \"foo\": \"bar\", \"bool0\": false, \"bool1\": true, \"arr\": [ 1, 2, 3, null, 5 ] }")
	printf(1, "new_obj.to_string()=%s\n", { json:to_json_string(new_obj) })
	json:put(new_obj)

	new_obj = json:tokener_parse("{ foo }")
	if (json:is_error(new_obj)) then
		printf(1, "got error as expected\n")
	end if

	new_obj = json:tokener_parse("foo")
	if (json:is_error(new_obj)) then
		printf(1, "got error as expected\n")
	end if

	new_obj = json:tokener_parse("{ \"foo")
	if (json:is_error(new_obj)) then
		printf(1, "got error as expected\n")
	end if

	/* test incremental parsing */
	tok = json:tokener_new()
	new_obj = json:tokener_parse_ex(tok, "{ \"foo", 6)
	if (json:is_error(new_obj)) then
		printf(1, "got error as expected\n")
	end if

	new_obj = json:tokener_parse_ex(tok, "\": {\"bar", 8)
	if (json:is_error(new_obj)) then
		printf(1, "got error as expected\n")
	end if

	new_obj = json:tokener_parse_ex(tok, "\":13}}", 6)
	printf(1, "new_obj.to_string()=%s\n", { json:to_json_string(new_obj) })
	json:put(new_obj)  
	json:tokener_free(tok)

	json:put(my_string)
	json:put(my_int)
	json:put(my_object)
	json:put(my_array)
